#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include "enpress.h"

int main(int argc,char **argv)
{
	int sockets[2];
	char *key="somekeys";
	EncryptInfo e_info=NULL;

	e_info=generate_key(key);	
	socketpair(AF_UNIX,SOCK_STREAM,0,sockets);

	if(!fork()) {
		/* Sending process */
		unsigned char *strings[]={"NICK Chunky\n","PASS fry\n","SERVER leela.111balmoral.co.uk 0 0 :Rah\n","CAPAB :TS4\n",NULL};
		unsigned char enc_buffer[512];
		unsigned char out_buffer[512];
		int length,enc_length,i;
		
		for(i=0;strings[i]!=NULL;i++) {
			
			encrypt_buffer(e_info,strings[i],enc_buffer,&enc_length);
			printf("Send %s\n",strings[i]);

			ircd_sprintf(out_buffer,5,"%04d",enc_length);
			send(sockets[0],out_buffer,4,0);
			send(sockets[0],enc_buffer,enc_length,0);
		}
		

	} else {
		/* Reciving process */
		unsigned char in_buffer[512];
		unsigned char clean_buffer[512];
		char length_buffer[5];
		int length,clean_len;
		int i;
	
		while(1) {
			recv(sockets[1],length_buffer,4,0);
			length_buffer[4]='\0';
			printf("String is %s\n",length_buffer);
			length=atoi(length_buffer);
			printf("Number is %d\n",length);

			memset(in_buffer,0,512);
			recv(sockets[1],in_buffer,length,0);

			memset(clean_buffer,0,512);
			clean_len=decrypt_buffer(e_info,in_buffer,clean_buffer,length);
			clean_buffer[clean_len]='\0';

			for(i=0;clean_buffer[i]!=0;i++) {
				if(clean_buffer[i]=='\n')
					clean_buffer[i]='\0';
			}
	
			printf("Cleaned buffer, it is %s\n",clean_buffer);
		}

	}
}
